/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Pais;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPais;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaPaisController")
@Scope("prototype")
public class BusquedaPaisController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Pais> plwPais;
    private MyListbox paisList;
    private Paging pagingPais;
    private Textbox txtNombre;
    private Row rowEquivalencia;
    private Listheader headerEquivalencia;

    public Paging getPagingPais() {
        return pagingPais;
    }

    public void setPagingPais(Paging pagingPais) {
        this.pagingPais = pagingPais;
    }

    public MyListbox getPaisList() {
        return paisList;
    }

    public void setPaisList(MyListbox paisList) {
        this.paisList = paisList;
    }

    public PagedListWrapper<Pais> getPlwPais() {
        return plwPais;
    }

    public void setPlwPais(PagedListWrapper<Pais> plwPais) {
        this.plwPais = plwPais;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public Listheader getHeaderEquivalencia() {
        return headerEquivalencia;
    }

    public void setHeaderEquivalencia(Listheader headerEquivalencia) {
        this.headerEquivalencia = headerEquivalencia;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new Pais());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        paisList.setItemRenderer(new RenderPais());
        paisList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Pais c = (Pais) paisList.getSelected();
                verPeriodo(c);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(Pais c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaPaisController", this);
        args.put("pais", c);
        args.put("paisList", paisList);

        openWindow("/gui/catalogos/editarPais.zul",
                Labels.getLabel("editarPaisController.window.title"), args, MODAL);
    }

    public void refreshLista() throws InterruptedException {
        HibernateSearchObject<Pais> paisBusqueda =
                new HibernateSearchObject<Pais>(Pais.class, pagingPais.getPageSize());

        paisBusqueda.addFilterLike("nombpais", "%" + txtNombre.getText().trim().concat("%"));

        paisBusqueda.addFilterEqual("activo", Boolean.TRUE);
        paisBusqueda.addSortAsc("nombpais");
        //paisBusqueda.addFilterNotEqual("paisId", -1);

        plwPais.init(paisBusqueda, paisList, pagingPais);

        if (paisList.getData().length == 0) {
            Messagebox.show(
                    Labels.getLabel("MSG.ningunRegistro"),
                    Labels.getLabel("busquedaPaisController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
        }
    }
}
